package sun.java2d.opengl;

import sun.java2d.pipe.BufferedContext;
import sun.java2d.InvalidPipeException;
import java.awt.Composite;
import sun.java2d.SunGraphics2D;
import sun.java2d.loops.GraphicsPrimitiveMgr;
import sun.java2d.loops.CompositeType;
import sun.java2d.loops.SurfaceType;
import sun.java2d.loops.GraphicsPrimitive;
import sun.java2d.pipe.BufferedMaskFill;

class OGLMaskFill extends BufferedMaskFill
{
    static void register() {
        GraphicsPrimitiveMgr.register(new GraphicsPrimitive[] { new OGLMaskFill(SurfaceType.AnyColor, CompositeType.SrcOver), new OGLMaskFill(SurfaceType.OpaqueColor, CompositeType.SrcNoEa), new OGLMaskFill(SurfaceType.GradientPaint, CompositeType.SrcOver), new OGLMaskFill(SurfaceType.OpaqueGradientPaint, CompositeType.SrcNoEa), new OGLMaskFill(SurfaceType.LinearGradientPaint, CompositeType.SrcOver), new OGLMaskFill(SurfaceType.OpaqueLinearGradientPaint, CompositeType.SrcNoEa), new OGLMaskFill(SurfaceType.RadialGradientPaint, CompositeType.SrcOver), new OGLMaskFill(SurfaceType.OpaqueRadialGradientPaint, CompositeType.SrcNoEa), new OGLMaskFill(SurfaceType.TexturePaint, CompositeType.SrcOver), new OGLMaskFill(SurfaceType.OpaqueTexturePaint, CompositeType.SrcNoEa) });
    }
    
    protected OGLMaskFill(SurfaceType srcType, CompositeType compType) {
        super(OGLRenderQueue.getInstance(), srcType, compType, OGLSurfaceData.OpenGLSurface);
    }
    
    @Override
    protected native void maskFill(int p0, int p1, int p2, int p3, int p4, int p5, int p6, byte[] p7);
    
    @Override
    protected void validateContext(SunGraphics2D sg2d, Composite comp, int flags) {
        OGLSurfaceData oglSurfaceData;
        try {
            oglSurfaceData = (OGLSurfaceData)sg2d.surfaceData;
        }
        catch (ClassCastException ex) {
            throw new InvalidPipeException("wrong surface data type: " + sg2d.surfaceData);
        }
        BufferedContext.validateContext(oglSurfaceData, oglSurfaceData, sg2d.getCompClip(), comp, null, sg2d.paint, sg2d, flags);
    }
}
